myGame.WorkDayActivityWebsite.prototype = {
  preload: function() {
  },

  create: function() {
    //Audio
    if (!myGame.music.work.isPlaying) {
      myGame.music.work.play('',0,1,true);
    }

    // Background
    this.stage.backgroundColor = '#000000';
    this.workDesk = this.add.sprite( 0,0, 'workDesk');

    // Computer
    this.workComputer = this.add.sprite(game.camera.view.centerX, game.camera.height + 50, 'workWebsiteComputer');
    this.workComputer.anchor.setTo(0.5, 1);

    // Prompt text
    myGame.drawPromptText("Design a nice website");

    // Timer text
    myGame.drawTimerText(this);
    myGame.timer.CountdownStart = 10000; // 2 minutes
    myGame.timer.CurrentTime = myGame.timer.CountdownStart;
    this.outOfTime = false;
    myGame.setupTimer(this);

    // Component background
    this.workWebsiteComponentBG = this.add.sprite(game.camera.view.centerX, 190, 'workWebsiteComponentBG');
    this.workWebsiteComponentBG.x = game.camera.view.centerX - (this.workWebsiteComponentBG.width/2);

    // Drop area
    this.workWebsiteDroparea = this.add.sprite(game.camera.view.centerX - 430, this.workComputer.y - this.workComputer.height + 270, 'workWebsiteDroparea');
    this.workWebsiteDroparea.visible = false;
    this.physics.enable(this.workWebsiteDroparea, Phaser.Physics.ARCADE);

    this.workWebsiteDropareaTemplates = game.add.group();
    this.currentTemplate = {};

    //Level rules
    this.GOALNUMBERPLACED = 9;
    this.COMPONENTWIDTH = 270;
    this.COMPONENTHEIGHT = 135;
    this.totalScore = 0;

    // Intantiate components
    this.workWebsiteComponents = game.add.group();
    this.drawComponentsOnScreen();

    // Component input
    this.workWebsiteComponents.forEach(function(component){
      game.physics.enable(component, Phaser.Physics.ARCADE);
      component.anchor.setTo(0.5, 0);
      component.body.setSize(120, 60, 0, 40);
      component.inputEnabled = true;
      component.input.enableDrag();
      component.events.onInputOver.add(this.showHoverInfo, this);
      component.events.onInputOut.add(this.hideHoverInfo, this);
      component.events.onInputDown.add(this.selectComponent, this);
      component.events.onDragStart.add(this.moveComponent, this);
      component.events.onDragStop.add(this.dropComponent, this);
    }, this);
    this.componentIsBeingMoved = false;
    this.componentBeingMoved = {};

    // Hover text
    myGame.setupHoverText(this);

    // continue button
    myGame.setupContinueButton(this);

    // Setup quit button
    myGame.setupQuitButton(this);
  },

  update: function() {
    // Timer
    myGame.monitorActivityTimer(this);

    if (!this.outOfTime) {
      if (this.componentIsBeingMoved) {
        // Check if component overlapping with anything
        this.workWebsiteDropareaTemplates.forEach(function(template) {
          if (this.physics.arcade.overlap(template, this.componentBeingMoved)) {
            template.loadTexture('workWebsiteDropareaComponentBlockActive');
            this.currentTemplate = template;
          } else {
            template.loadTexture('workWebsiteDropareaComponentBlock');
          }
        }, this);

        if (this.physics.arcade.overlap(this.workWebsiteDroparea, this.componentBeingMoved)) {
          this.workWebsiteDroparea.loadTexture('workWebsiteDropareaBlank');
          this.workWebsiteDropareaTemplates.visible = true;
        } else {
          this.workWebsiteDroparea.loadTexture('workWebsiteDroparea');
          this.workWebsiteDropareaTemplates.visible = false;
        }
      }
    } else {
      if (!this.continueButton.visible) {
        this.continueButton.visible = true;
      }
    }
  },

  drawComponentsOnScreen: function() {
    var componentBGWidthDibisibleAmount = Math.round(this.workWebsiteComponentBG.width/270);
    var componentBGHeightDibisibleAmount = Math.round(this.workWebsiteComponentBG.height/135);
    var componentXLocation = 0;
    var componentYLocation = 0;
    var tempArray = [];

    for (var i = 0; i < this.GOALNUMBERPLACED; i++) {
      tempArray.push(i);
    }

    tempArray.sort(function (a, b) {return Math.random() - 0.5;});

    for (var i = 0; i < this.GOALNUMBERPLACED; i++) {
      // Set component type
      switch (i+1) {
        case 1:
        componentDesc = "Text that tells visitors additional information about the client company. No one really reads, though.";
        break;
        case 2:
        componentDesc = "Navigational links to other pages with more information. Links are somewhat useful.";
        break;
        case 3:
        case 4:
        case 5:
        componentDesc = "A small image with text that gives visitors an idea of what the company does. People like images a lot.";
        break;
        case 6:
        componentDesc = "A large image with a link to view a list of the company's products. People don't like paying, but the client probably thinks this is important.";
        break;
        case 7:
        componentDesc = "A large image with inspiring headline text about the client company. This might be useful for getting people interested.";
        break;
        case 8:
        componentDesc = "The client's newsletter signup form. People hate giving away their email address.";
        break;
        default:
        componentDesc = "If the user needs help, this chat box would be useful... But people usually ignore these kinds of things.";
        break;
      }

      switch (i+1) {
        case 1:
        case 2:
        componentFunction = "text";
        break;
        case 3:
        case 4:
        case 5:
        componentFunction = "image-square";
        break;
        case 6:
        case 7:
        componentFunction = "image-full";
        break;
        default:
        componentFunction = "form";
        break;
      }

      var componentName = 'workWebsiteComponent' + (i + 1);
      var componentObject = this.workWebsiteComponents.create(0, 0, componentName);
      componentObject.componentOrder = tempArray[this.workWebsiteComponents.length - 1];
      componentObject.componentFunction = componentFunction;
      componentObject.desc = componentDesc;

      // Order the component on the page by default
      var componentBgStartingLocation = this.COMPONENTWIDTH - 60;
      var componentSpacer;

      if (componentObject.componentOrder < (this.GOALNUMBERPLACED / 2)) {
        componentSpacer = 25 * componentObject.componentOrder;

        // First row
        componentObject.defaultXLocation = componentBgStartingLocation + componentSpacer + (this.COMPONENTWIDTH * componentObject.componentOrder);
        componentObject.defaultYLocation = this.workWebsiteComponentBG.y + 20;
      } else {
        // Second row
        componentSpacer = 25 * (this.GOALNUMBERPLACED - componentObject.componentOrder - 1);

        componentObject.defaultXLocation = componentBgStartingLocation + componentSpacer + (this.COMPONENTWIDTH * (this.GOALNUMBERPLACED - componentObject.componentOrder - 1));
        componentObject.defaultYLocation = this.workWebsiteComponentBG.y + this.COMPONENTHEIGHT + 40;
      }

      componentObject.x = componentObject.defaultXLocation;
      componentObject.y = componentObject.defaultYLocation;
    }
  },

  showHoverInfo: function(component, pointer){
    if (!this.outOfTime) {
      if (!this.componentIsBeingMoved) {
        this.hoverText.setText(component.desc);
        this.hoverText.visible = true;
        this.hoverText.x = component.x;
        this.hoverText.y = component.y + component.height + 20;

        if (this.hoverText.x + this.hoverText.width/2 > game.width) {
          this.hoverText.x = game.width - this.hoverText.width/2 - 20;
        }

        if (this.hoverText.y + this.hoverText.height > game.height) {
          this.hoverText.y = game.height - this.hoverText.height - 20;
        }

        myGame.displayHoverTextBox(this);
      }
    }
  },

  hideHoverInfo: function(){
    this.hoverText.visible = false;
    this.hoverTextBox.visible = false;
  },

  moveComponent: function(component, pointer) {
    if (!this.outOfTime) {
      component.x = pointer.x;
      this.hideHoverInfo();
    } else {
      dropComponent(component);
    }
  },

  selectComponent: function(component, pointer) {
    if (!this.outOfTime) {
      myGame.sounds.outfit.pickup.play();
      this.moveComponent(component, pointer);
      this.componentBeingMoved = component;
      this.generateDropAreaOptions(this.componentBeingMoved);
      this.workWebsiteDroparea.loadTexture('workWebsiteDropareaBlank');
      this.componentIsBeingMoved = true;
      this.workWebsiteDroparea.visible = true;
    }
  },

  generateDropAreaOptions: function(component) {
    var dropAreaWidthDibisibleAmount = Math.round(this.workWebsiteDroparea.width/this.componentBeingMoved.width);
    var dropXLocations = [];

    var dropAreaHeightDibisibleAmount = Math.round(this.workWebsiteDroparea.height/this.componentBeingMoved.height);
    var dropYLocations = [];

    // X locations
    for (var i = 0; i < dropAreaWidthDibisibleAmount; i++) {

      // if the second of 2 divisible widths, subtract an extra amount - else don't
      dropXLocations[i] = this.workWebsiteDroparea.x + (8 * i) + Math.round(this.workWebsiteDroparea.width / dropAreaWidthDibisibleAmount * i);

      // Y locations
      for (var j = 0; j < dropAreaHeightDibisibleAmount; j++) {
        dropYLocations[j] = this.workWebsiteDroparea.y + (5 * j) + Math.round(this.workWebsiteDroparea.height / dropAreaHeightDibisibleAmount * j);

        //generate template
        var template = this.workWebsiteDropareaTemplates.create(dropXLocations[i], dropYLocations[j], 'workWebsiteDropareaComponentBlock');
        this.physics.enable(template, Phaser.Physics.ARCADE);
        template.body.setSize(230, 95, 20, 20);
        this.workWebsiteDropareaTemplates.sendToBack(template);

        switch (i) {
          case 0:
          template.xLocation = "left";
          break;
          case 1:
          template.xLocation = "center";
          break;
          default:
          template.xLocation = "right";
          break;
        }

        switch (j) {
          case 0:
          template.yLocation = "top";
          break;
          case 1:
          template.yLocation = "middle";
          break;
          default:
          template.yLocation = "bottom";
          break;
        }
      }
    }
  },

  destroyTemplates: function () {
    this.workWebsiteDropareaTemplates.forEach(function(template){
      template.kill();
    }, this);
  },

  dropComponent: function(component) {
    myGame.sounds.outfit.drop.play();
    this.componentBeingMoved.placed = false;
    this.physics.arcade.overlap(component, this.workWebsiteDroparea, this.placeComponent, null, this);
    this.destroyTemplates();
    this.componentIsBeingMoved = false;
    this.checkWebsiteProgress();
    this.workWebsiteDroparea.visible = false;
  },

  checkWebsiteProgress: function() {
    var placedComponents = 0;

    this.workWebsiteComponents.forEach(function(component){
      if (component.placed) {
        placedComponents++;
      }

    }, this);
    if (placedComponents == this.GOALNUMBERPLACED) {
      this.continueButton.visible = true;
    } else {
      this.continueButton.visible = false;
    }
  },

  placeComponent: function(component, droparea) {
    if (Object.keys(this.currentTemplate).length > 0) {
      this.componentBeingMoved.placed = true;

      // If component and a template overlap, place it there
      component.x = this.currentTemplate.x + (component.width/2);
      component.y = this.currentTemplate.y;
      component.xLocation = this.currentTemplate.xLocation;
      component.yLocation = this.currentTemplate.yLocation;

      // if these two overlap, move the old one back
      this.workWebsiteComponents.forEach(function(oldComponent){
        if (this.physics.arcade.overlap(component, oldComponent) && component != oldComponent) {
          this.resetComponentLocation(oldComponent);
        }

        if (component != oldComponent && component.x == oldComponent.x && component.y == oldComponent.y) {
          this.resetComponentLocation(oldComponent);
        }

      }, this);

      this.currentTemplate = {};
      this.calculateScore();
    }
  },

  resetComponentLocation: function(oldComponent) {
    oldComponent.x = oldComponent.defaultXLocation;
    oldComponent.y = oldComponent.defaultYLocation;
    oldComponent.placed = false;
  },

  calculateScore: function () {
    this.totalScore = 0;
    this.workWebsiteComponents.forEach(function(component){

      if (component.componentFunction == "text") {
        // If image with text is on the middle
        if (component.yLocation == "middle") {
          this.totalScore += 2;
          //If not in the center, subtract a point
          if (component.xLocation != "center") {
            this.totalScore--;
          }
        } else if (component.yLocation == "top") {
          // If it's on the top, 1 point
          this.totalScore += 1;
        }
          // Else, no points
        }

        if (component.componentFunction == "form") {
        // If form is in the middle
        if (component.yLocation == "middle") {
          this.totalScore += 2;
          //If it's not on the right, subtract a point
          if (component.xLocation != "right") {
            this.totalScore--;
          }
        } else if (component.yLocation == "bottom") {
          // If it's bottom, 1 point
          this.totalScore += 1;
          // Unless it's on the left side
          if (component.xLocation == "left") {
            this.totalScore--;
          }
        }
          // Else, no points
        }

        if (component.componentFunction == "image-square") {
        // If square image is on the left
        if (component.xLocation == "left") {
          this.totalScore += 2;
        } else if (component.yLocation == "bottom") {
          // If it's in the middle, 1 point
          this.totalScore += 1;
        }
          // Else, no points
        }

        if (component.componentFunction == "image-full") {
        // If image with text is on the top
        if (component.yLocation == "top") {
          this.totalScore += 2;
          //If it's on the left, subtract a point
          if (component.xLocation == "left") {
            this.totalScore--;
          }
        } else if (component.yLocation == "middle") {
          // If it's in the middle, 1 point
          this.totalScore += 1;
        }
          // Else, no points
        }

      }, this);

    if (this.totalScore >= 10) {
      myGame.player.workRating = "good";
    } else if (this.totalScore > 5) {
      myGame.player.workRating = "ok";
    } else {
      myGame.player.workRating = "bad";
    }

  },

  continue: function(){
    //Sounds
    myGame.sounds.dialog.buttonClick1.play();
    this.calculateScore();
    this.state.start('WorkDay');
  }
}